/* -*- mode: C; indent-tabs-mode: nil; c-basic-offset: 2 c-style: "BSD" -*- */
/*
 * gonzui - a source code search engine.
 *
 * Copyright (C) 2005 Satoru Takabayashi <satoru@namazu.org> 
 * Copyright (C) 2005 Keisuke Nishida <knishida@open-cobol.org>
 *      All rights reserved.
 *      This is free software with ABSOLUTELY NO WARRANTY.
 * 
 *  You can redistribute it and/or modify it under the terms of 
 *  the GNU General Public License version 2.
 */

#include <ruby.h>

#if 0
static VALUE
rb_delta_do_delta(VALUE obj, VALUE prev, VALUE data)
{
  long i;
  long n = RARRAY(prev)->len;
  VALUE *pp = RARRAY(prev)->ptr;
  VALUE *dp = RARRAY(data)->ptr;

  for (i = 0; i < n; i++) {
    VALUE tmp = dp[i];
    dp[i] = INT2FIX(FIX2INT(dp[i]) - FIX2INT(pp[i]));
    pp[i] = tmp;
  }
  return data;
}
#endif

static VALUE
rb_delta_do_undelta(VALUE obj, VALUE prev, VALUE data)
{
  long i;
  long n = RARRAY(prev)->len;
  VALUE *pp = RARRAY(prev)->ptr;
  VALUE *dp = RARRAY(data)->ptr;

  for (i = 0; i < n; i++) {
    dp[i] = pp[i] = INT2FIX(FIX2INT(pp[i]) + FIX2INT(dp[i]));
  }
  return data;
}

static VALUE
rb_delta_do_delta_list(VALUE obj, VALUE seq, VALUE delta_size, VALUE unit_size)
{
  int i, j;
  int dsize = FIX2INT(delta_size);
  int usize = FIX2INT(unit_size);
  int prev[dsize];
  long len = RARRAY(seq)->len;
  VALUE *p = RARRAY(seq)->ptr;

  memset(prev, 0, sizeof(int) * dsize);

  for (i = 0; i < len; i += usize) {
    for (j = 0; j < dsize; j++) {
      int n = FIX2INT(p[i + j]);
      p[i + j] = INT2FIX(n - prev[j]);
      prev[j] = n;
    }
  }
  return seq;
}

void Init_delta()
{
  VALUE mGonzui, mDelta;
  mGonzui = rb_define_module("Gonzui");
  mDelta = rb_define_module_under(mGonzui, "Delta");
  rb_define_method(mDelta, "do_delta_list", rb_delta_do_delta_list, 3);
  rb_define_method(mDelta, "do_undelta", rb_delta_do_undelta, 2);
}


