require 'test/unit'
require 'langscan/c'

class TestToken < Test::Unit::TestCase
  def test_comment
    LangScan::C.each_fragment("/* * */") {|f|
      assert_equal("/* * */", f.text)
      assert_equal(:comment, f.type)
    }
    LangScan::C.each_fragment("/* **/") {|f|
      assert_equal("/* **/", f.text)
      assert_equal(:comment, f.type)
    }
  end

  def test_c99_comment
    LangScan::C.each_fragment("// abc") {|f|
      assert_equal("// abc", f.text)
      assert_equal(:comment, f.type)
    }
    LangScan::C.each_fragment("//") {|f|
      assert_equal("//", f.text)
      assert_equal(:comment, f.type)
    }
    result_text = ["//def ", "\n"]
    result_type = [:comment, :space]
    LangScan::C.each_fragment("//def \n") {|f|
      assert_equal(result_text.shift, f.text)
      assert_equal(result_type.shift, f.type)
    }

  end

end
