#! /usr/bin/env ruby
$LOAD_PATH.unshift("..")
require 'test/unit'
require 'gonzui'
require 'gonzui'
require 'test-util'
require 'bdb'
include Gonzui

class AutopackTest < Test::Unit::TestCase
  include AutoPack::PackMethod
  def test_pack_method
    assert(pack_string("foo").is_a?(String))
    assert(pack_number(12345).is_a?(String))

    assert_equal("foo", unpack_string(pack_string("foo")))
    assert_equal(12345, unpack_number(pack_number(12345)))
  end

  def test_autopack
    targets = [
      [AutoPack::StringAndNumber,  "foo", 123],
      [AutoPack::NumberAndString,  123,   "foo"],
      [AutoPack::StringAndString,  "foo", "bar"],
    ]
    targets.each {|adaptor, key, value|
      tmpdb = "tmp.db"
      File.unlink(tmpdb) if File.exist?(tmpdb)
      db = BDB::Btree.open(tmpdb, nil, BDB::CREATE, 0644)
      db.extend(adaptor)

      db[key] = value
      assert_equal(value, db[key])
      assert(db.include?(key))

      db[key] = value
      assert_equal(value, db[key])

      db.delete(key)
      assert(db.empty?)
      db.close
      File.unlink(tmpdb)
    }
  end
end


