#! /usr/bin/env ruby
$LOAD_PATH.unshift("..")
require 'test/unit'
require 'fileutils'
require 'gonzui'
require 'test-util'
include Gonzui
include FileUtils

class ImporterTest < Test::Unit::TestCase
  include TestUtil

  def _test_import (method, parameter)
    config   = Config.new
    remove_db(config)
    make_archives

    importer = Importer.new(config)
    importer.send(method, parameter)
    begin
      importer.send(method, parameter)
      assert(false)
    rescue PackageAlreadyExists
      assert(true)
    end
    summary = importer.summary
    assert(summary.is_a?(String))
    assert(/\d+/.match(summary))
    importer.finish
    remove_db(config)
  end

  def test_import_archive
    _test_import(:add_archive, FOO_TGZ)
  end

  def test_import_by_apt
    _test_import(:add_by_apt, "portmap")
  end
end

