#! /usr/bin/env ruby
$LOAD_PATH.unshift("..")
require 'test/unit'
require 'gonzui'
require 'test-util'
include Gonzui

class IndexerTest < Test::Unit::TestCase
  include TestUtil

  def test_index
    config   = Config.new
    remove_db(config)
    dbm = DBM.open(config)
    content = File.read("foo/foo.c")
    mtime = File.mtime("foo/foo.c")
    indexer = Indexer.new(config, dbm, "foo/foo.c", content, mtime)
    passed = false
    indexer.index
    assert_equal(1, dbm.nfiles)
    assert(dbm.has_package?("foo"))
    assert(dbm.has_word?("main"))
    assert(dbm.consistent?)
  end
end
