#! /usr/bin/env ruby
$LOAD_PATH.unshift("..")
require 'test/unit'
require "test-util"
require 'langscan'

Dir.glob("../langscan/*/test/test-*.rb") {|filename|
  load filename
}

class TestLangScan < Test::Unit::TestCase
  SupportedLanguages = {
    "c"    =>   ["c",    LangScan::C],
    "java" =>   ["java", LangScan::Java],
    "ruby" =>   ["rb",   LangScan::Ruby],
    "text" =>   ["txt",  LangScan::Text],
#    "python" => ["py",   LangScan::Python],
  }

  def test_modules
    lang_abbrevs = LangScan.modules.map {|scanner| scanner.lang_abbrev }
    SupportedLanguages.each {|key, value|
      assert(lang_abbrevs.include?(key))
    }
  end

  def test_choose
    SupportedLanguages.each {|lang_name, item|
      extname, scanner = item
      assert_equal(scanner, LangScan.choose("foo." + extname))
    }
  end
end
