#! /usr/bin/env ruby
$LOAD_PATH.unshift("..")
require 'test/unit'
require 'gonzui'
require 'test-util'
include Gonzui

class PackageTest < Test::Unit::TestCase
  include TestUtil

  def test_package
    make_dist_tree
    directory = File.join("foo", "foo-0.1")
    package = Package.new(directory)

    assert_equal("foo-0.1", package.name)
    assert_equal(directory, package.directory)
    assert(File.directory?(package.directory))

    assert(package.nfiles > 0)
    package.each {|real_path, normalized_path| 
      assert_equal(package.name, normalized_path.split(File::SEPARATOR).first)
      assert(File.file?(real_path))
    }
  end
end
