#! /usr/bin/env ruby
$LOAD_PATH.unshift("..")
require 'test/unit'
require 'gonzui'
require 'test-util'
include Gonzui

class WordTest < Test::Unit::TestCase
  TYPE_TABLE = [:fundef, :funcall, :fundecl]

  def test_word_info
    word_id = 0
    word = "foo"
    path_id = 100
    seqno = 0
    byteno = 300
    lineno = 200
    TYPE_TABLE.each_with_index {|type, type_id|
      values = [word_id, path_id, seqno, byteno, lineno, type_id]
      info = WordInfo.new(*values)
      assert_equal(word_id, info.word_id)
      assert_equal(path_id, info.path_id)
      assert_equal(lineno, info.lineno)
      assert_equal(byteno, info.byteno)
      assert_equal(type_id, info.type_id)
      assert_equal(type, info.type)

      assert_equal(values, info.values)
    }
  end

  def test_digest_info
    byteno = 100
    length = 5
    TYPE_TABLE.each_with_index {|type, type_id|
      values = [byteno, length, type_id]
      info = DigestInfo.new(*values)
      assert_equal(byteno, info.byteno)
      assert_equal(length, length)
      assert_equal(type_id, info.type_id)
      assert_equal(values, info.values)
    }
  end
end
